// GuiRunnerDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "GuiRunnerDlg.h"
#include "resource.h"
#include <string>
#include <hash_map>

#include "../UnitTest++.h"
#include "../TestReporter.h"

class GuiReporter : public UnitTest::TestReporter
{
private:
	CGuiRunnerDlg& m_rDlg;

public:
	GuiReporter( CGuiRunnerDlg& rDlg ) : m_rDlg( rDlg ) {}
	~GuiReporter() {}

	void ReportTestStart(UnitTest::TestDetails const& test) override
	{
		m_rDlg.ReportTestStart( test );
	}

	void ReportFailure(UnitTest::TestDetails const& test, char const* failure) override
	{
		m_rDlg.ReportFailure( test, failure );
	}

	void ReportTestFinish(UnitTest::TestDetails const& test, float secondsElapsed) override
	{
		m_rDlg.ReportTestFinish( test, secondsElapsed );
	}

	void ReportSummary(int totalTestCount, int failedTestCount, int failureCount, float secondsElapsed) override
	{
		m_rDlg.ReportSummary( totalTestCount, failedTestCount, failureCount, secondsElapsed );
	}
};


#include <initguid.h>
#include <assert.h>
#pragma warning( disable : 4278 )
#pragma warning( disable : 4146 )
#if _MSC_VER >= 1400     // VC++ 8 or more
	#import "libid:80cc9f66-e7d8-4ddd-85b6-d9e6cd0e93e2" version("8.0") lcid("0") raw_interfaces_only named_guids
#elif _MSC_VER >= 1300     // VC++ 7 or more
	#import "libid:80cc9f66-e7d8-4ddd-85b6-d9e6cd0e93e2" version("7.0") lcid("0") raw_interfaces_only named_guids
#else
	#error Unsupported VC++ version.
#endif
#pragma warning( default : 4146 )
#pragma warning( default : 4278 )

using namespace UnitTest;

// CGuiRunnerDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(CGuiRunnerDlg, CDialog)

CGuiRunnerDlg::CGuiRunnerDlg(UnitTest::TestList& rTestList, IN const bool bRunAtStart, IN const bool bSuiteExpand, IN const bool bAutoExpand)
: CDialog(CGuiRunnerDlg::IDD, NULL), m_rTestList( rTestList ), m_RunCount( 0 ), m_TotalCount( 0 ), m_bRunAtStart( bRunAtStart ), m_bAutoExpand( bAutoExpand ), m_bSuiteExpand( bSuiteExpand ), m_bRunning( false )
{

}

CGuiRunnerDlg::~CGuiRunnerDlg()
{
}

void CGuiRunnerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TREE1, m_Tree);
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
	DDX_Control(pDX, IDC_RUN_COUNT, m_ctrlRunCount);
	DDX_Control(pDX, IDC_FAILURE_COUNT, m_ctrlFailureCount);
	DDX_Control(pDX, IDC_START, m_Start);
	DDX_Control(pDX, IDC_SUITE_COUNT, m_ctrlSuiteCount);
	DDX_Control(pDX, IDC_TEST_COUNT, m_ctrlTestCount);
}


BEGIN_MESSAGE_MAP(CGuiRunnerDlg, CDialog)
	ON_BN_CLICKED(IDC_START, &CGuiRunnerDlg::OnBnClickedStart)
	ON_NOTIFY(NM_CLICK, IDC_TREE1, &CGuiRunnerDlg::OnNMClickTree1)
	ON_BN_CLICKED(IDC_STOP, &CGuiRunnerDlg::OnBnClickedStop)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE1, &CGuiRunnerDlg::OnNMDblclkTree1)
END_MESSAGE_MAP()


enum ICON_TYPE
{
	ICON_TYPE_READY,
	ICON_TYPE_START,
	ICON_TYPE_FAIL,
	ICON_TYPE_SUCCESS,
	ICON_TYPE_CHECK
};

// CGuiRunnerDlg ޽ óԴϴ.

BOOL CGuiRunnerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ⿡ ߰ ʱȭ ۾ ߰մϴ.

	m_ImageList.Create( 16, 16, ILC_COLOR32, 0, 0 );
	m_Tree.SetImageList( &m_ImageList, LVSIL_NORMAL );

	TCHAR szTemp[MAX_PATH];
	GetSystemDirectory( szTemp, MAX_PATH );

	_tcscat_s( szTemp, MAX_PATH, _T( "\\Shell32.dll" ) );

	HICON hIconSmall;
	ExtractIconEx( szTemp, 23, NULL, &hIconSmall, 1 );
	m_ImageList.Add( hIconSmall );

	ExtractIconEx( szTemp, 137, NULL, &hIconSmall, 1 );
	m_ImageList.Add( hIconSmall );

	ExtractIconEx( szTemp, 131, NULL, &hIconSmall, 1 );
	m_ImageList.Add( hIconSmall );

	ExtractIconEx( szTemp, 146, NULL, &hIconSmall, 1 );
	m_ImageList.Add( hIconSmall );

	ExtractIconEx( szTemp, 77, NULL, &hIconSmall, 1 );
	m_ImageList.Add( hIconSmall );

	typedef stdext::hash_map<std::string, HTREEITEM> SUITE_CONTAINER;
	SUITE_CONTAINER suites;

	int testCount = 0, suiteCount = 0;
	const Test* pTest = m_rTestList.GetHead();
	while( pTest != NULL )
	{
		const std::string strSuite = pTest->m_details.suiteName;

		HTREEITEM hSuite = NULL;
		SUITE_CONTAINER::iterator itr = suites.find( strSuite );
		if( itr != suites.end() )
		{
			hSuite = itr->second;
		}
		else
		{
			hSuite = m_Tree.InsertItem( CString( strSuite.c_str() ), ICON_TYPE_READY, ICON_TYPE_READY );
			m_Tree.SetCheck( hSuite );
			suites.insert( SUITE_CONTAINER::value_type( strSuite, hSuite ) );
			suiteCount++;
		}

		HTREEITEM hTest = m_Tree.InsertItem( CString( pTest->m_details.testName ), ICON_TYPE_READY, ICON_TYPE_READY, hSuite );
		m_Tree.SetCheck( hTest );
		m_Tree.SetItemData( hTest, (DWORD_PTR)pTest );
		testCount++;
		m_TotalCount++;

		pTest = pTest->next;
	}
	if( m_bSuiteExpand == true )
	{
		HTREEITEM hTreeItem = m_Tree.GetChildItem( TVI_ROOT );
		while( hTreeItem != NULL )
		{
			m_Tree.Expand( hTreeItem, TVE_EXPAND );
			hTreeItem = m_Tree.GetNextSiblingItem( hTreeItem );
		}
	}

	CString strTemp;
	strTemp.Format( _T( "%d" ), testCount );
	m_ctrlTestCount.SetWindowText( strTemp );
	strTemp.Format( _T( "%d" ), suiteCount );
	m_ctrlSuiteCount.SetWindowText( strTemp );

	Reset();

	if( m_bRunAtStart == true )
		OnBnClickedStart();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CGuiRunnerDlg::ReportTestStart( TestDetails const& test )
{
	CString strTest( test.testName );
	CString strSuite( test.suiteName );

	HTREEITEM hSuite = m_Tree.GetChildItem( TVI_ROOT );

	while( hSuite != NULL )
	{
		if( m_Tree.GetItemText( hSuite ) == strSuite )
		{
			m_Tree.SetItemImage( hSuite, ICON_TYPE_START, ICON_TYPE_START );
			HTREEITEM hTest = m_Tree.GetChildItem( hSuite );
			while( hTest != NULL )
			{
				if( m_Tree.GetItemText( hTest ) == strTest )
				{
					m_Tree.SetItemImage( hTest, ICON_TYPE_START, ICON_TYPE_START );
					return;
				}
				hTest = m_Tree.GetNextSiblingItem( hTest );
			}
		}

		hSuite = m_Tree.GetNextSiblingItem( hSuite );
	}
}

void CGuiRunnerDlg::ReportFailure( TestDetails const& test, char const* failure )
{
	if( m_FailureDetails.empty() == true )
	{
		m_Progress.SetBarColor( RGB( 255, 0, 0 ) );
	}
	m_FailureDetails.push_back( FailureDetails( test ) );

	CString strTemp;
	strTemp.Format( _T( "%d" ), m_FailureDetails.size() );
	m_ctrlFailureCount.SetWindowText( strTemp );

	CString strTest( test.testName );
	CString strSuite( test.suiteName );

	HTREEITEM hSuite = m_Tree.GetChildItem( TVI_ROOT );

	while( hSuite != NULL )
	{
		if( m_Tree.GetItemText( hSuite ) == strSuite )
		{
			HTREEITEM hTest = m_Tree.GetChildItem( hSuite );
			while( hTest != NULL )
			{
				if( m_Tree.GetItemText( hTest ) == strTest )
				{
					CString strFilename( test.filename );
					if( strFilename.Left( 2 ) != _T( ".\\ " ) )
					{
						TCHAR szTemp[512];
						GetCurrentDirectory( 512, szTemp );
						const int length = (int)_tcslen( szTemp );
						if( strFilename.Left( length ).CompareNoCase( szTemp ) == 0 )
							strFilename = CString( _T( "." ) ) + strFilename.Mid( length );
					}

					CString strFailure;
					strFailure.Format( _T( "%s(%d): error: Failure in %s: %s\n" ), strFilename, test.lineNumber, CString( test.testName ), CString( failure ) );

					HTREEITEM hFailure = m_Tree.InsertItem( strFailure, ICON_TYPE_FAIL, ICON_TYPE_FAIL, hTest );
					m_Tree.SetItemState( hFailure, 0, TVIS_STATEIMAGEMASK );
					m_Tree.SetItemData( hFailure, (DWORD_PTR)(DWORD)m_FailureDetails.size()-1 );
					if( m_bAutoExpand == true )
						m_Tree.Expand( hTest, TVE_EXPAND );
					return;
				}
				hTest = m_Tree.GetNextSiblingItem( hTest );
			}
		}

		hSuite = m_Tree.GetNextSiblingItem( hSuite );
	}
}

void CGuiRunnerDlg::ReportTestFinish( TestDetails const& test, float secondsElapsed )
{
	m_RunCount++;

	CString strTemp;
	strTemp.Format( _T( "%d/%d" ), m_RunCount, m_TotalCount );
	m_ctrlRunCount.SetWindowText( strTemp );
	m_Progress.SetPos( m_RunCount*100 );

	CString strTest( test.testName );
	CString strSuite( test.suiteName );

	HTREEITEM hSuite = m_Tree.GetChildItem( TVI_ROOT );

	while( hSuite != NULL )
	{
		if( m_Tree.GetItemText( hSuite ) == strSuite )
		{
			HTREEITEM hTest = m_Tree.GetChildItem( hSuite );
			while( hTest != NULL )
			{
				if( m_Tree.GetItemText( hTest ) == strTest )
				{
					if( m_Tree.ItemHasChildren( hTest ) )
						m_Tree.SetItemImage( hTest, ICON_TYPE_CHECK, ICON_TYPE_CHECK );
					else
						m_Tree.SetItemImage( hTest, ICON_TYPE_SUCCESS, ICON_TYPE_SUCCESS );

					int testCount = (int)m_Tree.GetItemData( hSuite )-1;
					if( testCount == 0 )
					{
						HTREEITEM hTest = m_Tree.GetChildItem( hSuite );
						while( hTest != NULL )
						{
							if( m_Tree.GetCheck( hTest ) )
							{
								if( m_Tree.ItemHasChildren( hTest ) )
								{
									m_Tree.SetItemImage( hSuite, ICON_TYPE_CHECK, ICON_TYPE_CHECK );
									return;
								}
							}
							hTest = m_Tree.GetNextSiblingItem( hTest );
						}
						m_Tree.SetItemImage( hSuite, ICON_TYPE_SUCCESS, ICON_TYPE_SUCCESS );
					}
					else
						m_Tree.SetItemData( hSuite, (DWORD_PTR)testCount );

					return;
				}
				hTest = m_Tree.GetNextSiblingItem( hTest );
			}
		}

		hSuite = m_Tree.GetNextSiblingItem( hSuite );
	}
}

void CGuiRunnerDlg::ReportSummary( int totalTestCount, int failedTestCount, int failureCount, float secondsElapsed )
{
	if( m_TotalCount != 0 )
		m_Start.EnableWindow( TRUE );

	m_bRunning = false;
}

UINT RunTest( LPVOID lpParam )
{
	CGuiRunnerDlg* dlg = (CGuiRunnerDlg*)lpParam;
	CTreeCtrl& rTree = dlg->GetTree();

	GuiReporter reporter( *dlg );
	TestResults result(&reporter);

	Timer overallTimer;
	overallTimer.Start();

	HTREEITEM hSuite = rTree.GetChildItem( TVI_ROOT );
	while( hSuite != NULL && dlg->IsRunning() == true )
	{
		if( rTree.GetCheck( hSuite ) )
		{
			HTREEITEM hTest = rTree.GetChildItem( hSuite );
			while( hTest != NULL && dlg->IsRunning() == true )
			{
				if( rTree.GetCheck( hTest ) )
				{
					Test const* curTest = (Test const*)rTree.GetItemData( hTest );

					Timer testTimer;
					testTimer.Start();
					result.OnTestStart(curTest->m_details);

					curTest->Run(result);

					int const testTimeInMs = testTimer.GetTimeInMs();
					result.OnTestFinish(curTest->m_details, testTimeInMs/1000.0f);
				}

				hTest = rTree.GetNextSiblingItem( hTest );
			}
		}
		hSuite = rTree.GetNextSiblingItem( hSuite );
	}

	float const secondsElapsed = overallTimer.GetTimeInMs() / 1000.0f;
	reporter.ReportSummary(result.GetTotalTestCount(), result.GetFailedTestCount(), result.GetFailureCount(), secondsElapsed);

//	RunAllTests( reporter, dlg->GetTestList(), 0 );

	return 0;
}

void CGuiRunnerDlg::OnBnClickedStart()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	Reset();

	m_Start.EnableWindow( FALSE );
	m_bRunning = true;

	AfxBeginThread( &RunTest, this );
}

void CGuiRunnerDlg::Reset()
{
	m_RunCount = 0;
	m_FailureDetails.clear();
	RefreshTotalCount();

	m_Progress.SetBarColor( RGB( 0, 255, 0 ) );

	HTREEITEM hSuite = m_Tree.GetChildItem( TVI_ROOT );
	while( hSuite != NULL )
	{
		if( m_Tree.GetCheck( hSuite ) )
		{
			m_Tree.SetItemImage( hSuite, ICON_TYPE_READY, ICON_TYPE_READY );

			HTREEITEM hTest = m_Tree.GetChildItem( hSuite );
			while( hTest != NULL )
			{
				if( m_Tree.GetCheck( hTest ) )
				{
					m_Tree.SetItemImage( hTest, ICON_TYPE_READY, ICON_TYPE_READY );
					HTREEITEM hChildItem;
					while( ( hChildItem = m_Tree.GetChildItem( hTest ) ) != NULL )
					{
						m_Tree.DeleteItem( hChildItem );
					}
				}
				hTest = m_Tree.GetNextSiblingItem( hTest );
			}
		}

		hSuite = m_Tree.GetNextSiblingItem( hSuite );
	}

	m_Progress.SetPos( 0 );
}

void CGuiRunnerDlg::RefreshTotalCount()
{
	m_TotalCount = 0;
	HTREEITEM hSuite = m_Tree.GetChildItem( TVI_ROOT );
	while( hSuite != NULL )
	{
		if( m_Tree.GetCheck( hSuite ) )
		{
			int testCount = 0;

			HTREEITEM hTest = m_Tree.GetChildItem( hSuite );

			while( hTest != NULL )
			{
				if( m_Tree.GetCheck( hTest ) )
				{
					m_TotalCount++;
					testCount++;
				}

				hTest = m_Tree.GetNextSiblingItem( hTest );
			}

			m_Tree.SetItemData( hSuite, (DWORD_PTR)testCount );
		}
		hSuite = m_Tree.GetNextSiblingItem( hSuite );
	}

	m_Progress.SetRange32( 0, m_TotalCount*100 );

	CString strTemp;
	strTemp.Format( _T( "%d/%d" ), 0, m_TotalCount );
	m_ctrlRunCount.SetWindowText( strTemp );

	if( m_TotalCount == 0 )
		m_Start.EnableWindow( FALSE );

	strTemp.Format( _T( "%d/%d" ), 0, m_TotalCount );
	m_ctrlRunCount.SetWindowText( strTemp );
	m_ctrlFailureCount.SetWindowText( _T( "0" ) );
}


void CGuiRunnerDlg::OnNMClickTree1(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	*pResult = 0;

	CPoint	ptCurMouse;
	GetCursorPos( &ptCurMouse );
	m_Tree.ScreenToClient( (LPPOINT)&ptCurMouse );

	UINT uFlags;
	HTREEITEM hItem = m_Tree.HitTest( ptCurMouse, &uFlags );

	if( hItem != NULL && ( uFlags & TVHT_ONITEMSTATEICON ) )
	{
		*pResult = 1;
	
		if( m_bRunning == false )
		{
			const bool bCheck = m_Tree.GetCheck( hItem ) != FALSE;
			m_Tree.SetCheck( hItem, !bCheck );
			RefreshTotalCount();
		}
	}
}

void CGuiRunnerDlg::OnBnClickedStop()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_bRunning = false;
}

OUT const int CGuiRunnerDlg::GetTreeDepth( IN const HTREEITEM hItem ) const
{
	if( hItem == NULL )
		return -1;

	int depth = 0;
	HTREEITEM hParentItem = hItem;
	while( ( hParentItem = m_Tree.GetParentItem( hParentItem ) ) != NULL )
	{
		depth++;
	}
	return depth;
}

void CGuiRunnerDlg::OnNMDblclkTree1(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	*pResult = 0;

	CPoint	ptCurMouse;
	GetCursorPos( &ptCurMouse );
	m_Tree.ScreenToClient( (LPPOINT)&ptCurMouse );

	UINT uFlags;
	HTREEITEM hItem = m_Tree.HitTest( ptCurMouse, &uFlags );

	if( hItem != NULL )
	{
		*pResult = 1;

		m_Tree.SelectItem( hItem );

		const int depth = GetTreeDepth( hItem );
		switch( depth )
		{
		case 1:	// test
			{
				Test const* curTest = (Test const*)m_Tree.GetItemData( hItem );
				goToLineInSourceCode( CString( curTest->m_details.filename ), curTest->m_details.lineNumber );
			}
			break;

		case 2:
			{
				DWORD failureIndex = (DWORD)m_Tree.GetItemData( hItem );
				FailureDetails& rDetails = m_FailureDetails.at( failureIndex );
				goToLineInSourceCode( rDetails.Filename, rDetails.linenumber );
			}
			break;	// failure
		}
	}
}

void CGuiRunnerDlg::goToLineInSourceCode( CString fileName, int line )
{
	if( fileName.Left( 2 ) == _T( ".\\" ) )
	{
		TCHAR szTemp[512];
		GetCurrentDirectory( 512, szTemp );
		fileName = szTemp + fileName.Mid( 1 );
	}
	USES_CONVERSION;

	CComPtr< IRunningObjectTable > pIRunningObjectTable;
	HRESULT hr = ::GetRunningObjectTable( 0, &pIRunningObjectTable );

	CComPtr< IEnumMoniker > pIEnumMoniker;
	hr = pIRunningObjectTable->EnumRunning( &pIEnumMoniker );

	CComPtr< EnvDTE::_DTE > pIEnvDTE;
	while ( true )
	{
		ULONG celtFetched;
		CComPtr< IMoniker > pIMoniker;
		if ( S_OK != pIEnumMoniker->Next( 1, &pIMoniker, &celtFetched ) )
			break;

		CComPtr< IBindCtx > pIBindCtx; 
		hr = ::CreateBindCtx( NULL, &pIBindCtx ); 

		LPOLESTR pszDisplayName;
		pIMoniker->GetDisplayName( pIBindCtx, NULL, &pszDisplayName );

		TRACE( "Moniker %s\n", W2A( pszDisplayName ) );

		CString strDisplayName( pszDisplayName );
		CComPtr< IMalloc > pIMalloc;
		::CoGetMalloc( 1, &pIMalloc );
		pIMalloc->Free( pszDisplayName );

		if ( strDisplayName.Right( 4 ) == _T(".sln") 
			|| strDisplayName.Find( _T("VisualStudio.DTE") ) >= 0 )
		{
			CComPtr< IUnknown > pIUnknown;
			pIRunningObjectTable->GetObject( pIMoniker, &pIUnknown );
			pIUnknown->QueryInterface( &pIEnvDTE );
			if( pIEnvDTE.p )
				break;
		}
	}

	if ( pIEnvDTE.p )
	{
		CComPtr< EnvDTE::Documents > pIDocuments;
		HRESULT result = pIEnvDTE->get_Documents( &pIDocuments );
		if ( !SUCCEEDED( result ) )
			return;

		if( pIDocuments.p == NULL )
			return;
		assert( pIDocuments.p );

		CComPtr< EnvDTE::Document > pIDocument;
		CComBSTR bstrFileName( fileName );
		CComVariant type=_T("Text");
		CComVariant read=_T("False");
		result = pIDocuments->Open( bstrFileName, 
			type.bstrVal,
			read.bVal, 
			&pIDocument );
		if ( !SUCCEEDED( result ) )
			return;

		assert( pIDocument.p );

		CComPtr< IDispatch > pIDispatch;
		result = pIDocument->get_Selection( &pIDispatch );
		if ( !SUCCEEDED( result ) )
			return;

		CComPtr< EnvDTE::TextSelection > pITextSelection;
		pIDispatch->QueryInterface( &pITextSelection );

		assert( pITextSelection.p );

		result = pITextSelection->GotoLine( line, TRUE );
		if ( !SUCCEEDED( result ) )
			return;
	}
}

CGuiRunnerDlg::FailureDetails::FailureDetails( const UnitTest::TestDetails& rDetails ) : Filename( rDetails.filename ), linenumber( rDetails.lineNumber )
{

}