#pragma once

#include "resource.h"
#include "afxcmn.h"
#include "afxwin.h"
#include "TextProgressCtrl.h"
#include <vector>

namespace UnitTest
{
	class TestList;
	class TestDetails;
};
// CGuiRunnerDlg ȭ Դϴ.

class AFX_EXT_CLASS CGuiRunnerDlg : public CDialog
{
	DECLARE_DYNAMIC(CGuiRunnerDlg)

public:
	CGuiRunnerDlg(UnitTest::TestList& rTestList, IN const bool bRunAtStart = true, IN const bool bSuiteExpand = true, IN const bool bAutoExpand = true );   // ǥ Դϴ.
	virtual ~CGuiRunnerDlg();

	enum { IDD = IDD_DIALOG1 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	void goToLineInSourceCode( CString fileName, int line );
	OUT const int GetTreeDepth( IN const HTREEITEM hItem ) const;

	DECLARE_MESSAGE_MAP()
public:
	void ReportTestStart(UnitTest::TestDetails const& test);
	void ReportFailure(UnitTest::TestDetails const& test, char const* failure);
	void ReportTestFinish(UnitTest::TestDetails const& test, float secondsElapsed);
	void ReportSummary(int totalTestCount, int failedTestCount, int failureCount, float secondsElapsed);

	virtual BOOL OnInitDialog();
private:
	CTreeCtrl m_Tree;
	UnitTest::TestList& m_rTestList;
	CImageList m_ImageList;
	CTextProgressCtrl m_Progress;
public:
	afx_msg void OnBnClickedStart();
	UnitTest::TestList& GetTestList() { return m_rTestList; }
	CTreeCtrl& GetTree() { return m_Tree; }

private:
	int m_RunCount, m_TotalCount;
	bool m_bRunning;
	bool m_bRunAtStart;
	bool m_bAutoExpand;
	bool m_bSuiteExpand;

	struct FailureDetails
	{
		FailureDetails( const UnitTest::TestDetails& rDetails );
		CString Filename;
		int linenumber;
	};
	std::vector<FailureDetails> m_FailureDetails;

private:
	void Reset();
	void RefreshTotalCount();

private:
	CStatic m_ctrlRunCount;
	CStatic m_ctrlFailureCount;
	CButton m_Start;
	CStatic m_ctrlSuiteCount;
	CStatic m_ctrlTestCount;
public:
	afx_msg void OnNMClickTree1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedStop();
	OUT const bool IsRunning() const { return m_bRunning; }
	afx_msg void OnNMDblclkTree1(NMHDR *pNMHDR, LRESULT *pResult);
};

#define GUI_RUNNER 	CGuiRunnerDlg dlg( UnitTest::Test::GetTestList() ); dlg.DoModal()
